<?php

namespace catchAdmin\api\controller;

use catchAdmin\alarm\model\AlarmRecords;
use catchAdmin\hydraulic\model\DeviceMold;
use catchAdmin\hydraulic\model\Hydraulic as ModelHydraulic;
use catchAdmin\hydraulic\model\maintenancemapper;
use catchAdmin\permissions\model\Users;
use catchAdmin\wind\model\Fan;
use catchAdmin\wind\model\Wind;
use catchAdmin\worklocation\model\WorkRecord as ModelWorkRecord;
use catcher\base\CatchRequest as Request;
use catcher\CatchResponse;
use catcher\base\CatchController;
use Hydraulic;
use \think\facade\Db;
use Workerman\Worker;
use WorkRecord;

error_reporting(0);
class Api extends CatchController
{
    //设备告警
    public function alarm()
    {

        $token = $_GET['token'];
        if (!$token || $token != '22723927C') {
            json_fail('缺少token或者token不对');
        }
        $param = json_decode(optimize_json(file_get_contents("php://input")), true);

        if (json_last_error() != 0) {
            json_fail('解析异常', json_last_error_msg());
        }

        //校验imei是否存在
        if (!isset($param['IMEI']) ||  $param['IMEI'] == '') {
            json_fail('缺少设备IMEI号参数');
        }
        $Imei = $param['IMEI'];
        if (!$this->IsImei($Imei)) {
            json_fail('该Imei号不存在');
        }
        $aram = new AlarmRecords();
        $content = [
            'device_number' => $Imei,
            'alarm_type' => $param['Type'],
            'alarm_reason' => $param['Reason'],
            'comment' => json_encode($param['Data']),
            'start_time' => $param['Time'],
        ];
        $aram->save($content);
        return json_success('获取成功', '', $Imei);
    }

    /**
     * @Descripttion: 上传紧固模式
     * @name: likang
     * @return {*}
     */
    public function UploadWorkRecordFA()
    {

        $token = $_GET['token'];
        if (!$token || $token != '22723927C') {
            json_fail('缺少token或者token不对');
        }
        $param = json_decode(optimize_json(file_get_contents("php://input")), true);

        if (json_last_error() != 0) {
            json_fail('解析异常', json_last_error_msg());
        }

        //校验imei是否存在
        if (!isset($param['IMEI']) ||  $param['IMEI'] == '') {
            json_fail('缺少设备IMEI号参数');
        }
        $Imei = $param['IMEI'];


        if (!$this->IsImei($Imei)) {
            json_fail('该Imei号不存在');
        }
        if (!($param['PublishVersion']) ||  $param['PublishVersion'] == '') {

            $param['PublishVersion'] = 0;
        }
        $version = $param['PublishVersion'];
        $content = $this->Conversion($param, 1);

        $this->IssuedWorkRecord($content, $Imei);
        return json_success('获取成功', '', $Imei);
    }
    /**
     * @Descripttion: 上传维护模式
     * @name: likang
     * @return {*}
     */
    public function UploadWorkRecordMA()
    {
        $token = $_GET['token'];
        if (!$token || $token != '22723927C') {
            json_fail('缺少token或者token不对');
        }
        $param = json_decode(optimize_json(file_get_contents("php://input")), true);

        if (json_last_error() != 0) {
            json_fail('解析异常', json_last_error_msg());
        }

        //校验imei是否存在
        if (!isset($param['IMEI']) ||  $param['IMEI'] == '') {
            json_fail('缺少设备IMEI号参数');
        }
        $Imei = $param['IMEI'];
        if (!$this->IsImei($Imei)) {
            json_fail('该Imei号不存在');
        }
        if (!($param['PublishVersion']) ||  $param['PublishVersion'] == '') {

            $param['PublishVersion'] = 0;
        }
        $version = $param['PublishVersion'];
        $content = $this->Conversion($param, 2);
        $this->IssuedWorkRecord($content, $Imei);
        return json_success('获取成功', '', $Imei);
    }






    /**
     * @Descripttion: Imei 是否存在
     * @name: likang
     * @param {*} $imei
     * @return {*}
     */
    private function IsImei($imei)
    {
        $data =  ModelHydraulic::where('imei', $imei)->find();
        if ($data) {
            return true;
        } else {
            return false;
        }
    }
    /**
     * @Descripttion: 
     * @name: likang
     * @param {*} $data 数据内容
     * @param {*} $type 工作类型
     * @return {*}
     */
    private function Conversion($data, $type)
    {
        $content = [];
        $content['creator_id'] =  Users::where('username', $data['Username'])->value('id');
        $content['wrench_number'] = trim($data['WrenchNumber']);
        $content['wind_number'] = trim($data['WindFieldNumber']);
        $content['fan_number'] = trim($data['TurbineNumber']);
        $content['fan_model'] = trim($data['Model']);
        $content['parts'] = trim($data['PartNumber']);
        $content['work_sign'] = trim($data['WorkPos']);
        $content['boit_type'] = trim($data['BoltModel']);
        $content['bolt_number'] = trim($data['BoltNumber']);
        $content['boit_total'] = trim($data['BoltTotal']);
        $content['set_torque'] = trim($data['SetTorque']);
        $content['fastening_torque'] = trim($data['FasteningTorque']);
        $content['set_stress'] = trim($data['SetStress']);
        $content['fastening_stress'] = trim($data['FasteningStress']);
        $content['fastening_status'] = trim($data['FasteningStatus']);
        $content['fastening_time'] = trim($data['Time']);
        $content['move_angle'] = trim($data['WrenchAngle']);
        $content['imei'] = trim($data['IMEI']);
        $content['FasteningStatus'] = trim($data['FasteningStatus']);
        if ($type == 2) {
            $content['wrench_type'] = trim($data['FasteningStatus']);
            if ($data['FasteningStatus'] == 3) {
                if ($content['move_angle'] > 2) {
                    $content['FasteningStatus'] = 2;
                }
            } else {
                $content['FasteningStatus'] = 1;
            }
        } else {
            $content['wrench_type'] = 1;
        }
        $workRecod = new ModelWorkRecord();
        $bool = $workRecod->save($content);
        //校验工作

        // //校验风机编号
        // $this->CheckFanNumber($content['wind_number'], $content['fan_number'], $content['fan_model'], $content['creator_id']);
        // //校验部件

        // $this->CheckParts($content['parts'], $content['creator_id']);

        // //校验工作位置
        // $this->CheckWork($content['fan_model'], $content['parts'], $content['work_sign'], $content['creator_id']);

        return $content;
        //下发上传的记录
    }
    /**
     * @Descripttion: 下发工作记录
     * @name: likang
     * @return {*}
     */
    private function IssuedWorkRecord($content, $IMEI)
    {
        $where = [];
        $data = [
            'id' => $content['wind_number'] . '_' . $content['fan_number'] . '_' . $content['fan_model'] . '_' . $content['parts'] . '_' . $content['work_sign'],
            'wnum' => $content['wind_number'],
            'fnum' => $content['fan_number'],
            'fmodel'  => $content['fan_model'],
            'parts' => $content['parts'],
            'work' =>  $content['work_sign'],
            'bnum' =>  $content['boit_total'],
            'torque' => $content['fastening_torque']
        ];
        $time = msectime();
        $where[] = ['ContentId', '=', $data['id']];
        $where[] = ['ContentType', '=', 'WorkRecord'];

        $bool =  Db::name('publish')->where($where)->find();
        if ($bool) {
            $addContent = [
                'Imei' => $IMEI,
                'Type' => 'update',
                'Version' => $time,
                'Content' => json_encode($data)
            ];

            Db::name('publish')->where($where)->update($addContent);
        } else {
            $addContent = [
                'Imei' => $IMEI,
                'Type' => 'add',
                'Version' => $time,
                'Content' => json_encode($data),
                'ContentId' => $data['id'],
                'AddTime' => $time,
                'Status' => 1,
                'ContentType' => 'WorkRecord'
            ];
            Db::name('publish')->save($addContent);
        }
    }
    /**
     * @Descripttion: 校验该风机机位号是否存在  不存在则创建并下发
     * @name: likang
     * @param {*} $wind_number  风场编号  
     * @param {*} $number
     * @param {*} $fan_model
     * @return {*}
     */
    public function CheckFanNumber($wind_number, $number, $fan_model, $creator_id)
    {
        $wind_id = Wind::where('number', $wind_number)->value('id');
        $fan_model_id = DeviceMold::where('device_type', 4)->where('name', $fan_model)->value('id');
        $where = [];
        $where[] = ['wind_id', '=', $wind_id];
        $where[] = ['number', '=', $number];
        $where[] = ['fan_model', '=', $fan_model_id];
        $bool = Fan::where($where)->find();
        if (!$bool) {
            $content = [
                'wind_id' => $wind_id,
                'number' => $number,
                'fan_model' => $fan_model_id,
                'creator_id' => $creator_id
            ];

            $fan = new Fan();
            $fan->save($content);
        }
    }
    /**
     * @Descripttion: 校验部件是否存在  不存在则添加上
     * @name: likang
     * @param {*} $parts_name
     * @param {*} $creator_id
     * @return {*}
     */
    public function CheckParts($parts_name, $creator_id)
    {
        $bool =   maintenancemapper::where('device_type', 1)->where('name', $parts_name)->find();
        if (!$bool) {
            $Mainten = new maintenancemapper();
            $content = [
                'device_type' => 1,
                'value' => msectime(),
                'name' => $parts_name,
                'creator_id' => $creator_id
            ];
            $Mainten->save($content);
        }
    }
    /**
     * @Descripttion: 
     * @name: likang
     * @return {*}
     */
    public function CheckWork($Fan_model, $parts, $work_name, $creator_id)
    {
        $where = [];
        $model_id =   DeviceMold::where('device_type', 4)->where('name', $Fan_model)->value('id');
        $parts = maintenancemapper::where('device_type', 1)->where('name', $parts)->value('value');
        $where[] = ['fan_model', '=', $model_id];
        $where[] = ['parts', '=', $parts];
        $where[] = ['device_type', '=', 2];
        $bool = maintenancemapper::where($where)->where('name', $work_name)->find();
        if (!$bool) {
            $Mainten = new maintenancemapper();
            $content = [
                'device_type' => 2,
                'fan_model' => $model_id,
                'parts' => $parts,
                'value' => msectime(),
                'name' => $work_name,
                'creator_id' => $creator_id
            ];
            $Mainten->save($content);
        }
    }
}
