<?php

use think\migration\Migrator;
use think\migration\db\Column;
use Phinx\Db\Adapter\MysqlAdapter;

class PublishAck extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('publish_ack', ['engine' => 'InnoDB', 'collation' => 'utf8mb4_general_ci', 'comment' => '回复的信息', 'id' => 'id', 'signed' => true, 'primary_key' => ['id']]);
        $table->addColumn('PublishVersion', 'integer', ['limit' => MysqlAdapter::INT_BIG, 'null' => true, 'signed' => true, 'comment' => '版本',])
            ->addColumn('PublishContent', 'text', ['limit' => MysqlAdapter::TEXT_LONG, 'null' => true, 'signed' => true, 'comment' => '下发的内容',])
            ->addColumn('AddTime', 'integer', ['limit' => MysqlAdapter::INT_BIG, 'null' => true, 'signed' => true, 'comment' => '创建时间',])
            ->addColumn('Succ', 'integer', ['limit' => MysqlAdapter::INT_REGULAR, 'null' => true, 'signed' => true, 'comment' => '1 成功  -1 失败',])
            ->addColumn('Imei', 'string', ['limit' => 50, 'null' => true, 'signed' => true, 'comment' => '网关imei',])
            ->addColumn('AckTime', 'integer', ['limit' => MysqlAdapter::INT_BIG, 'null' => true, 'signed' => true, 'comment' => '回复时间',])
            ->addColumn('Extra', 'text', ['limit' => MysqlAdapter::TEXT_LONG, 'null' => true, 'signed' => true, 'comment' => '回复的内容',])
            ->create();
    }
}
